"""WAeUP portal certificates
"""
import grok
from zope.component.interfaces import IFactory
from waeup.interfaces import ICertificate, ICertificateContainer

class Certificate(grok.Container):
    """A certificate.
    """
    grok.implements(ICertificate)

    def __init__(self, code='NA'):
        self.code = code

class CertificateContainer(grok.Container):
    """See interfaces for description.
    """
    grok.implements(ICertificateContainer)
    grok.require('waeup.manageUniversity')

    def addCertificate(self, certificate):
        if not ICertificate.providedBy(certificate):
            raise TypeError('CertificateContainers contain only '
                            'ICertificate instances')
        self[certificate.code] = certificate
        return

    def clear(self):
        keys = self.keys()
        for key in keys:
            del self[key]

class CertificateContainerFactory(grok.GlobalUtility):
    """A factory for certificate containers.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.CertificateContainer')
    title = u"Create a new certificate container.",
    description = u"This factory instantiates new certificate containers."

    def __call__(self):
        return CertificateContainer()

    def getInterfaces(self):
        return implementedBy(CertificateContainer)
